﻿using System;
using System.Windows.Forms;

namespace ncvcommentmado
{
    public partial class CommentForm : Form
    {
        //--------------------
        // TODO:    CommentForm フィールド
        //--------------------

        public delegate bool PostCommandEventHandler(bool isOwner, bool isAnonymous, string comment);
        public event PostCommandEventHandler PostCommand;

        //--------------------
        // TODO:    CommentForm メソッド
        //--------------------

        public CommentForm()
        {
            InitializeComponent();
        }

        //--------------------
        // TODO:    CommentForm プロパティ
        //--------------------

        public bool PostButtonEnabled
        {
            get { return postButton.Enabled; }
            set { postButton.Enabled = value; }
        }

        //--------------------
        // TODO:    CommentForm イベントハンドラ（的なもの）
        //--------------------

        /// <summary>
        /// コマンドキーボードショートカット対応
        /// </summary>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            Keys code = keyData & Keys.KeyCode;
            Keys mod = keyData & Keys.Modifiers;

            if (mod == Keys.Control)
            {
                switch (code)
                {
                    case Keys.Enter:
                        Post();
                        return true;
                    case Keys.A:
                        commentTextBox.SelectAll();
                        return true;
                }
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        void postButton_Click(object sender, EventArgs e)
        {
            Post();
        }

        //--------------------
        // TODO:    CommentForm サブルーチン
        //--------------------

        void Post()
        {
            if (postButton.Enabled)
            {
                if (PostCommand(isOwnerCheckBox.Checked, isAnonymousCheckBox.Checked, commentTextBox.Text)) {// 成功
                    commentTextBox.Text = "";
                }
            }
        }
    }
}
